#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "a_train.h"

struct car* add_car(struct car* first,const char* target) {
    struct car* newcar = calloc(1, sizeof(struct car));

    if(target == NULL){
        return 0;
    }
    
    if(first == NULL){
        strcpy(newcar->value, target);
        newcar->next = NULL;
        return newcar;
    }
    strcpy(newcar->value,target);
    newcar->next = NULL;    
    struct car *this = first;
    while(this->next != NULL){
        this = this->next;         
    }
    this->next = newcar;
    return first;  
}

void print_train(struct car* first) {
    for(struct car* this = first; this != NULL; this = this->next){
        printf("%s ", this->value);
    }
}

void cancel_train(struct car* first) {   
    if(first == NULL){
        return;
    }
    if(first->next != NULL){
       cancel_train(first->next);
       first->next = NULL;
    }
    else if(first->next == NULL){
       free(first);
    }
}



struct car* clear_train(struct car* first, const char* target) {
    if(first == NULL){
        return 0;
    } 

    if(first->next == NULL){
      int result = strcmp(first->value, target);
        if(result == 0){
           free(first);
           return 0;          
        }
        else{
            return first;
        }
    }
    struct car* prev = first;
    while(prev->next->next != NULL){
        int x = strcmp(first->value, target);
        if(x == 0){
            prev = first->next;
            free(first);
            return prev;
            
        }
        x = strcmp(prev->next->value, target);
        if(x == 0){ 
            struct car* third = prev->next->next;
            free(prev->next);
            prev->next = third;                
         
        }
        prev = prev->next;
   } 
   if(prev->next->next == NULL) {
        int x = strcmp(first->value, target);
        if(x == 0){
            prev = first->next;
            free(first);
            return prev;

        }
        x = strcmp(prev->next->value, target);
        if(x == 0){
            struct car* third = prev->next->next;
            free(prev->next);
            prev->next = third;
        }
   
        //free(prev->next);
        //prev->next = NULL;
    }

    
   return first;
      
}
